module ShapePicture_Editor exposing (main)
--Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import TypeHolder exposing (Model, Msg(..))
import Manager.UpdateManager exposing (update)
import Manager.ViewManager   exposing (view)
import Manager.StateManager  as StM
import Util.Util exposing (Picture)

main = Browser.application
        { init = init
        , subscriptions = subscriptions
        , update = update
        , view = documentView
        , onUrlChange = UrlChanged
        , onUrlRequest = LinkClicked
        }
-- INIT
init : () -> Url.Url -> Nav.Key-> (Model, Cmd Msg)
init _ url key =
    ( Model
        StM.Standby
        []
        0
        (Ok " Init")
        ( Picture
            ( Url.Url
                Url.Http
                "www.informatik.uni-halle.de"
                Nothing
                "/im/1285058520_1381_00_800.jpg"
                Nothing
                Nothing
            )
            800
            600
        )
        ,url = url
        ,key = key
        ,errorString = ""
        ,stringToShapes = "[ { \"shape\": { \"polygon\": [ { \"x\": \"157\", \"y\": \"265\" }, { \"x\": \"26\", \"y\": \"116\" }, { \"x\": \"34\", \"y\": \"212\" }, { \"x\": \"229\", \"y\": \"188\" }, { \"x\": \"117\", \"y\": \"124\" } ] }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } }, { \"shape\": { \"rect\": { \"x\": \"486\", \"y\": \"60\", \"width\": \"84\", \"height\": \"74\" } }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } }, { \"shape\": { \"ellipse\": { \"cx\": \"410\", \"cy\": \"319\", \"rx\": \"110\", \"ry\": \"52\" } }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } }, { \"shape\": { \"circle\": { \"cx\": \"395\", \"cy\": \"104\", \"r\": \"66\" } }, \"shapeprop\": { \"hFC\": \"white\", \"hFO\": \"0.5\", \"hSC\": \"red\", \"hSW\": \"3\", \"hSO\": \"1.0\", \"uFC\": \"white\", \"uFO\": \"0.0\", \"uSC\": \"red\", \"uSW\": \"3\", \"uSO\": \"1.0\", \"title\": \"default\", \"body\": \"default\" } } ]"
      }
    , Cmd.none
    )
-- SUBSCRIPTIONS
subscriptions : Model -> Sub Msg
subscriptions model = Sub.none
-- VIEW
documentView : Model -> Browser.Document Msg
documentView model = { title = "ShapePicture_Editor"
                     , body = [view model]
                     }
